#pragma once
#include <streams.h>
#pragma warning(disable:4995)
#include <comdef.h>

class IVCamRenderConfig;

// smart ptrs
_COM_SMARTPTR_TYPEDEF(IFilterGraph,		IID_IFilterGraph);
_COM_SMARTPTR_TYPEDEF(IGraphBuilder,	IID_IGraphBuilder);
_COM_SMARTPTR_TYPEDEF(IBaseFilter,		IID_IBaseFilter);
_COM_SMARTPTR_TYPEDEF(IMediaEvent,		IID_IMediaEvent);
_COM_SMARTPTR_TYPEDEF(IMediaControl,	IID_IMediaControl);
_COM_SMARTPTR_TYPEDEF(IMediaSeeking ,	IID_IMediaSeeking);

class CVCamSDKImpl
{
public:
	CVCamSDKImpl(void);
	~CVCamSDKImpl(void);

	void	SetVCamDeviceName(BSTR pDevName);

	void	SetLicenseCode(BSTR pRegStr);

	HRESULT PlayVideoFile(LPCTSTR fileName);
	LONG	GetCurrentVideoDuration(); // ms as UNIT
	LONG	GetCurrentVideoPosition();
	HRESULT	SetCurrentVideoPosition(LONG pos);

	HRESULT PlayVideoDevice(UINT idx);

	bool	IsPlaying();
	void	StopPlay();
	
	void	CaptureScreen(RECT rcZone);
	void	StopCapture();
	
	void	PlayBuffer(PBYTE rgb24Buffer, DWORD dwWidth, DWORD dwHeight);

	void	AddOverlay(BYTE *pRgb32Buffer, long width, long height, long px, long py, long whichOne = 0);
	void	AddText(LPCTSTR olText, PLOGFONT pLogFont, COLORREF ftColor, COLORREF bkColor, long px, long py, long bkType, long whichOne = 0);
	
	void	ChangeDefaultFPS(int fps = 25);
	void	ChangeDefaultVideoSize(int szType = 2);
	bool	GetOnlySupportOneSize();
	void	SetOnlySupportOneSize(bool onesize = true);
	void	SetCustomSize(long use_custom_size, long width, long height);

public:
	friend DWORD WINAPI ScreenCaptureThread(LPVOID lpParam);
	friend DWORD WINAPI GraphCheckThread(LPVOID lpParam);

protected:
	IGraphBuilderPtr		m_pGraph;
	IMediaSeekingPtr		m_pMS;
	IMediaControlPtr		m_pMC;
	IBaseFilterPtr			m_pVCamRenderer;
	IVCamRenderConfig*		m_pConfig;

	HANDLE					m_hGraphCheckThread;
	BOOL					m_bStopGraphCheck;
	HANDLE					m_hScreenCaptureThread;
	BOOL					m_bStopCapture;
	RECT					m_rcCaptureZone;
};
